msdevblog/blog/urls.py
from django.urls import path

from .views import *
from .feeds import LatestPostsFeed

app_name = 'blog'

urlpatterns = [
    path('', PostListView.as_view(), name='home'),
    path('new-post/', PostCreateView.as_view(), name='post-new'),
    path('update-post/<slug:slug>/', PostUpdateView.as_view(), name='post-update'),
    path('by-category/<slug:slug>/', ByCategoryListView.as_view(), name='category'),
    path('by-tag/<slug:slug>/', ByTagListView.as_view(), name='tag'),
    path('feedback/', feedback, name='feedback'),
    path('search/', search_view, name='post-search'),
    path('feed/', LatestPostsFeed(), name='post-feed'),
    path('about/', about_view, name='about'),
    path('<slug:slug>/', post_detail, name='post-detail'),
]

msdevblog/msdevblog/urls.py
from django.contrib import admin
from django.urls import path, include
from django.contrib.sitemaps.views import sitemap
from blog.sitemaps import PostSitemap
from django.conf import settings
from django.conf.urls.static import static

handler404 = 'blog.views.page_not_found'

sitemaps = {
    'posts': PostSitemap,
}


urlpatterns = [
    path('blog/', include('blog.urls', namespace='blog')),
    path('members/', include('members.urls')),
    path('captcha/', include('captcha.urls')),
    path('admin/', admin.site.urls),
    path('sitemap.xml', sitemap, {'sitemaps': sitemaps}, name='django.contrib.sitemaps.views.sitemap'),
    path("ckeditor5/", include('django_ckeditor_5.urls'), name="ck_editor_5_upload_file"),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

if settings.DEBUG:
    urlpatterns.append(path('__debug__/', include('debug_toolbar.urls')))

msdevblog/blog/models.py
from django.conf import settings
from django.db import models
from django.urls import reverse

from taggit.managers import TaggableManager
from taggit.models import TagBase, GenericTaggedItemBase
from django_ckeditor_5.fields import CKEditor5Field

# стандартная библиотека не работает с русскими символами, используем свою
from msdevblog.utilites import slugify as to_slugify


# Пакет taggit использует функцию django.utils.text.slugify() для расчета slug.
# Переопределяем модели Тегов с целью использовать свою функцию slugify.
class BlogTag(TagBase):
    def slugify(self, tag, i=None):
        return to_slugify(tag)

    class Meta:
        verbose_name = 'Тег'
        verbose_name_plural = 'Теги'


class TaggedBlog(GenericTaggedItemBase):
    tag = models.ForeignKey(
        BlogTag,
        on_delete=models.CASCADE,
        related_name="%(app_label)s_%(class)s_items",
    )


class PublishedManager(models.Manager):
    """ Менеджер для модели, возвращает только опубликованные посты """
    def get_queryset(self):
        return super().get_queryset().filter(status=Post.Status.PUBLISHED)


class Category(models.Model):
    title = models.CharField(max_length=255, verbose_name='Название категории')
    slug = models.SlugField(max_length=255, unique=True, db_index=True, verbose_name='URL')

    def __str__(self):
        return self.title

    class Meta:
        verbose_name = 'Категория'
        verbose_name_plural = 'Категории'


class Post(models.Model):
    class Status(models.TextChoices):
        DRAFT = 'DF', 'Черновик'           # Draft
        PUBLISHED = 'PB', 'Опубликовано'   # Published

    user = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.CASCADE, related_name='posts', verbose_name='Автор поста')
    # on_delete=models.SET(1) - первая кат-рия будет "Все категории" задается в настройках
    cat = models.ForeignKey(Category, on_delete=models.SET(1),
                            related_name='posts', verbose_name='Категория')
    title = models.CharField(max_length=255, verbose_name='Название поста')
    slug = models.SlugField(max_length=255, unique_for_date='time_created', verbose_name='URL')
    body = CKEditor5Field('Текст поста', config_name='extends')
    time_created = models.DateTimeField(auto_now_add=True, verbose_name='Время создания')
    time_updated = models.DateTimeField(auto_now=True, verbose_name='Время последнего изменения')
    status = models.CharField(max_length=2, choices=Status.choices,
                              default=Status.DRAFT, verbose_name='Статус')
    tags = TaggableManager(through=TaggedBlog, verbose_name='Теги')

    published = PublishedManager()
    objects = models.Manager()  # указываем и менеджер по умолчанию, иначе он будет недоступен

    def __str__(self):
        return f'{self.title} - {self.user}'

    def save(self, *args, **kwargs):
        """ Добавляем slug на основе поля title, если он не был передан """
        if not self.slug or self.slug == '':
            self.slug = to_slugify(self.title)
        return super().save(*args, **kwargs)

    def get_absolute_url(self):
        return reverse('blog:post-detail', args=[self.slug])

    class Meta:
        verbose_name = 'Пост'
        verbose_name_plural = 'Посты'
        ordering = ['-time_created', 'cat']


class Comment(models.Model):
    user = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.CASCADE,
                             related_name='comments', verbose_name='Автор комментария')
    post = models.ForeignKey(Post, on_delete=models.CASCADE,
                             related_name='comments', verbose_name='Пост')
    reply_post = models.ForeignKey('Comment', on_delete=models.DO_NOTHING,
                                   null=True, blank=True,
                                   verbose_name='Комментарий на который отвечаем')
    body = models.TextField(verbose_name='Текст комментария')
    time_created = models.DateTimeField(auto_now_add=True, verbose_name='Время создания')

    class Meta:
        verbose_name = 'Комментарий'
        verbose_name_plural = 'Комментарии'
        ordering = ['-time_created']

msdevblog/blog/forms.py
from django import forms

from captcha.fields import CaptchaField
from django.core.exceptions import ValidationError
from django_ckeditor_5.widgets import CKEditor5Widget

from msdevblog.utilites import slugify
from .models import Post, Comment

from taggit.forms import TagWidget


class PostForm(forms.ModelForm):

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.fields["body"].required = False

    def clean_slug(self):
        # Не запускается, если поле "slug" пустое!!!
        # По этой причине оно скрыто и установлено значение 'none'.
        return slugify(self.cleaned_data['title'])

    def clean_tags(self):
        # Приложение виснет, если пытается записать теги с одинаковым slug
        # Например пользователь передан теги 'Flask' и 'Фласк',
        # дли них будет сформирован одинаковый slug = 'flask'
        # при попытке сохранения это приведет к зависанию приложения.
        tags = self.cleaned_data['tags']
        tags_slug = {slugify(tag) for tag in tags}
        if len(tags) != len(tags_slug):
            raise ValidationError("Проверьте поле Теги, возможно имеются теги с одинаковым смыслом.")
        return tags

    class Meta:
        model = Post
        fields = ('cat', 'title', 'slug', 'body', 'tags', 'status')

        widgets = {
            'cat': forms.Select(attrs={'class': 'required input_field'}),
            'title': forms.TextInput(attrs={'class': 'required input_field',
                                            'placeholder': 'Укажите название поста'}),
            # метод clean_slug не запускается, если поле "slug" пустое,
            # по этой причине оно скрыто и добавлено значение "none".
            'slug': forms.TextInput(attrs={'class': 'required input_field',
                                           'placeholder': 'URL-адрес поста (slug)',
                                           'value': 'none', 'type': 'hidden'}),
            'body': CKEditor5Widget(attrs={'class': 'django_ckeditor_5 input_field'}, config_name='extends'),
            'tags': TagWidget(attrs={'class': 'required input_field'}),
            'status': forms.Select(attrs={'class': 'required input_field'}),
        }


class CommentForm(forms.ModelForm):
    class Meta:
        model = Comment
        fields = ('body',)
        labels = {'body': 'Ваш комментарий'}

        widgets = {
            'body': forms.Textarea(attrs={'class': 'required input_field'}),
        }


class FeedbackForm(forms.Form):
    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.fields['captcha'].widget.attrs['class'] = 'required input_field'

    theme = forms.CharField(max_length=255, label='Тема сообщения',
                            widget=forms.TextInput(attrs={'class': 'required input_field'}))
    text = forms.CharField(widget=forms.Textarea, label='Текст сообщения')
    email = forms.EmailField(widget=forms.EmailInput(attrs={'class': 'required input_field'}),
                             label='Ваш e-mail для обратной связи')
    captcha = CaptchaField(label='Введите текст с картинки',
                           error_messages={'invalid': 'Неверно указан текст с картинки'})

msdevblog/blog/views.py
from django.contrib.auth.mixins import UserPassesTestMixin
from django.contrib.postgres.search import SearchVector, SearchQuery, SearchRank
from django.core.exceptions import ValidationError
from django.db.models import Subquery
from django.urls import reverse
from django.views.decorators.http import require_POST
from django.views.generic import ListView, CreateView, UpdateView
from django.shortcuts import get_object_or_404, render, redirect
from django.contrib import messages
from django.conf import settings

from msdevblog.settings import PAGINATE_BY_CONST
from .models import Post, Category, Comment, BlogTag
from .forms import PostForm, CommentForm, FeedbackForm
from .tasks import send_feedback_mail


class PostListView(ListView):
    model = Post
    template_name = 'blog/post_list.html'
    extra_context = {'selected': 'home'}
    paginate_by = PAGINATE_BY_CONST

    def get_queryset(self):
        return Post.published.select_related('user').prefetch_related('tags') \
            .only('title', 'slug', 'body', 'time_updated', 'user__username')


def post_detail(request, slug):
    post = get_object_or_404(Post.objects.select_related('user') \
                             .only('time_updated', 'slug', 'title', 'body',
                                   'user__id', 'user__username', 'user__first_name', 'user__last_name', 'user__bio',
                                   'user__git') \
                             .prefetch_related('tags'), slug=slug)
    if request.method == 'POST' and request.user.is_authenticated and request.user.is_email_activated:
        form = CommentForm(request.POST)
        if form.is_valid():
            form.instance.user = request.user
            form.instance.post = post
            form.save()

    form = CommentForm()
    comments = Comment.objects.values('time_created', 'body', 'user__username').filter(post=post)
    is_author = bool(request.user == post.user)
    return render(request, 'blog/post_detail.html',
                  {'object': post, 'form': form, 'comments': comments, 'is_author': is_author})


class PostCreateView(UserPassesTestMixin, CreateView):
    model = Post
    form_class = PostForm
    template_name = 'blog/post_create.html'
    extra_context = {'selected': 'create_post'}

    def test_func(self):
        return self.request.user.is_authenticated

    def form_valid(self, form):
        """ Передаем пользователя в форму """
        if not self.request.user.is_email_activated:
            raise ValidationError("Пользователь не подтвердил e-mail!")
        form.instance.user = self.request.user
        return super().form_valid(form)


class PostUpdateView(UserPassesTestMixin, UpdateView):
    model = Post
    form_class = PostForm
    template_name = 'blog/post_create.html'
    extra_context = {'selected': 'create_post'}

    def test_func(self):
        post_owner = Post.objects.only('user__id').get(slug=self.kwargs['slug'])
        return bool(self.request.user.is_authenticated and post_owner.user_id == self.request.user.id)

    def get_queryset(self):
        return Post.objects.select_related('cat', 'user')\
            .only('title', 'slug', 'body', 'status',
                  'cat__title',
                  'user__id', 'user__is_email_activated')


class ByCategoryListView(ListView):
    model = Post
    template_name = 'blog/post_list.html'

    def get_queryset(self):
        cat = Subquery(Category.objects.values('id').filter(slug=self.kwargs['slug']))
        return Post.published.select_related('user').prefetch_related('tags') \
            .only('title', 'slug', 'body', 'time_updated', 'user__username').filter(cat=cat)


class ByTagListView(ListView):
    model = Post
    template_name = 'blog/post_list.html'

    def get_queryset(self):
        tag = Subquery(BlogTag.objects.values('name').filter(slug=self.kwargs['slug']))
        return Post.published.select_related('user').prefetch_related('tags') \
            .only('title', 'slug', 'body', 'time_updated', 'user__username')\
            .filter(tags__name__in=[tag]).distinct()


def feedback(request):
    """ Отправляет сообщение администратору сайта. """
    if request.method == 'POST':
        form = FeedbackForm(request.POST)
        if form.is_valid():
            send = send_feedback_mail.delay(
                subject=form.cleaned_data['theme'],
                message=form.cleaned_data['text'] + '\nE-mail: ' + form.cleaned_data['email'],
                from_email=settings.SERVER_EMAIL,
                recipient_list=settings.EMAIL_TO_FEEDBACK
            )
            if send:
                messages.add_message(request, messages.SUCCESS, 'Ваше сообщение отправлено!')
                form = FeedbackForm()
            else:
                messages.add_message(request, messages.SUCCESS, 'Что то пошло не так, попробуйте повторить позже...')
    else:
        form = FeedbackForm()
    return render(request, 'blog/feedback.html', {'form': form, 'selected': 'feedback'})


@require_POST
def search_view(request):
    if request.method == 'POST':
        searched = request.POST['searched']  # <input name="searched" ...
        if not searched:
            return redirect(reverse('blog:home'))

        # Простой поиск по нескольким полям
        # object_list = Post.published.annotate(
        #         search=SearchVector('title', 'body'), ).filter(search=searched)

        # Поиск с выделением основ слов и ранжирование результатов
        # config='russian' - настраиваем удаление русских стоп слов
        search_vector = SearchVector('title', 'body', config='russian')
        search_query = SearchQuery(searched, config='russian')
        object_list = Post.published.select_related('user').prefetch_related('tags') \
            .only('title', 'slug', 'body', 'time_updated', 'user__username')\
            .annotate(search=search_vector, rank=SearchRank(search_vector, search_query))\
            .filter(search=search_query).order_by('-rank')

        return render(request, 'blog/post_list.html', {'object_list': object_list, 'search_key': searched})
    return render(request, 'blog/post_list.html')


def page_not_found(request, exception):
    return render(request, 'blog/base.html')


def about_view(request):
    return render(request, 'blog/about.html', {'selected': 'about'})

msdevblog/blog/templates/blog/about.html
{% extends 'blog/base.html' %}

{% block content %}

    <h2>О сайте</h2>
    <p>На данном сайте я буду публиковать посты на интересные мне темы по web-разработке и обо всем, что хоть как-то с ней связано.
        Любой желающий может принять участие и поделиться своими знаниями в данной области написав статью или прокомментировать существующую.
    </p>

<br>
<br>
    <h2>Правила сайта</h2>
    <p>1. Запрещено публиковать материалы, содержащие оскорбления, угрозы, дискриминацию, насилие и пропаганду незаконных действий.</p>
    <p>2. Запрещено копировать материалы с других сайтов без указания авторства и ссылки на источник.</p>
    <p>3. Запрещено использовать сайт для распространения спама, вирусов и других вредоносных программ.</p>
    <p>4. Администратор сайта оставляет за собой право удалить любой материал, который не соответствует правилам сайта.</p>
    <p>5. Пользователи могут оставлять комментарии под материалами, но запрещено оскорблять других пользователей и нарушать правила сайта.</p>
    <p>6. Администратор сайта имеет право изменять правила сайта без предварительного уведомления пользователей.</p>

{% endblock %}

msdevblog/blog/templates/blog/base.html
{% load static %}
<!DOCTYPE html>
<html lang="ru">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>MS DevBlog</title>
    <link rel="shortcut icon" type="image/jpg" href="{% static 'images/favicon.ico' %}"/>
    <link href="{% static 'css/blog.css' %}" rel="stylesheet" type="text/css" />
</head>

<body>

    <div id="container">

        <div id="plate_header">
            <div id="site_title"><h1><a href="{% url 'blog:home' %}"><span>MS</span> DevBlog</a></h1></div>
            <div id="tooplate_menu">
                {% include "blog/includes/main_menu.html" with selected=selected user=user%}
            </div>
        </div>

        <div id="tooplate_main">
            <div class="col_w960 hr_divider">
                    <div class="col_w200 lp_box float_r">
                        <div class="cleaner h10"></div>

                        <h3>Поиск</h3>
                        <ul class="tooplate_list">
                            <form class="d-flex" method="post" action="{% url 'blog:post-search' %}">
                                {% csrf_token %}
                              <input name="searched" class="required input_field w-200" type="search" placeholder="Поиск" aria-label="Search">
                              <button class="submit_btn float_r none" type="submit">Поиск</button>
                            </form>
                        </ul>

                        <h3>Категории</h3>
                        <ul class="tooplate_list">
                            {% for category in categories %}
                                <li><a href="{% url 'blog:category' category.slug %}">{{ category.title }}</a></li>
                            {% endfor %}
                        </ul>

                        <h3>Новые посты</h3>
                        <ul class="tooplate_list">
                            {% for new_post in new_posts %}
                                <li><a href="{% url 'blog:post-detail' new_post.slug %}">{{ new_post.title }}</a></li>
                            {% endfor %}
                        </ul>

                        <h3>Теги</h3>
                        <div class="tooplate_list">
                            {% for tag in tags_list %}
                            <span class="item">
                            _<a href="{% url 'blog:tag' tag.slug %}">{{ tag.name }}</a>_
                            </span>
                            {% endfor %}
                        </div>

                        <a href="{% url 'blog:post-feed' %}"><img src="{% static 'images/rss.png' %}" alt="rss"></a>
                    </div>

                    <div class="col_w730 float_l">
                        <div class="post_box">

                            {% block content %}
                            <div class="post_box_content">
                                <h3>Страница не найдена...</h3>
                            </div>
                            {% endblock %}
                            <div class="cleaner h10"></div>
                            <div class="cleaner h10"></div>
                            <div class="cleaner h10"></div>

                        </div>
                    </div>
            </div>
        </div>
    </div> <!--  end "container"  -->

        <div id="tooplate_footer_wrapper">
            <div id="tooplate_footer">
                Copyright © 2023 <a target="_blank" href="https://www.linkedin.com/in/%D1%81%D0%B5%D1%80%D0%B3%D0%B5%D0%B9-m-7b36a7280/">Сергей Матвеев</a>
            </div>
        </div>
</body>
</html>

msdevblog/blog/templates/blog/exception_page.html
{% extends 'flats/base.html' %}

{% block content %}
<div class="post_box_content list">
	<h2>Что то пошло не так ...</h2>
	<br>
	<p>Мы уже знаем об этом и скоро все починим.</p>
</div>
{% endblock %}

msdevblog/blog/templates/blog/feedback.html
{% extends 'blog/base.html' %}

{% block content %}

<div class="post_box_content">
    <h2>Обратная связь</h2>

    {% if messages %}
    <div class="cleaner h10"></div>
        {% for message in messages %}
        <p {% if message.tags %} class="{{ message.tags }}"{% endif %}>
            {{ message }}
        </p>
        {% endfor %}
    <div class="cleaner h10"></div>
    {% endif %}

    <div id="cp_contact_form">
        <form method="post" name="contact">
            {% csrf_token %}
            {{ form.as_p }}
            <div class="cleaner h10"></div>
            <div class="cleaner h10"></div>
            <input type="submit" value="Отправить" id="submit" name="submit" class="submit_btn float_l" />
        </form>
    </div>
</div>

{% endblock %}

msdevblog/blog/templates/blog/post_create.html
{% extends 'blog/base.html' %}

{% block content %}
    <div class="post_box_content">
    <h3>Новый пост</h3>
        {% if messages %}
            {% for message in messages %}
            <p {% if message.tags %} class="{{ message.tags }}"{% endif %}>
                {{ message }}
            </p>
            {% endfor %}
        <div class="cleaner h10"></div>
        {% endif %}
        {% if user.is_email_activated %}
            <div id="cp_contact_form">
                <form method="post" name="contact">
                    {% csrf_token %}
                    {{ form.media }}
                    {{ form.as_p }}
                    <br>
                    <input type="submit" value="Сохранить" id="submit" name="submit" class="submit_btn float_l" />
                </form>
            </div>
        {% else %}
            <p>Подтвердите адрес E-mail: {{ user.email }} чтобы создать пост.</p>
            <p><a href="{% url 'repeat-send-email' %}">Повторно отправить сообщение для активации e-mail.</a></p>
        {% endif %}
    </div>
{% endblock %}

msdevblog/blog/templates/blog/post_detail.html
{% extends 'blog/base.html' %}

{% load blog_tags %}

{% block content %}
<div class="post_box_content">
    <h2><a href="{% url 'blog:post-detail' object.slug %}">{{ object.title }}</a></h2>
    <p>{{ object.body|safe }}</p>
    <p><span><b>{{ object.time_updated|date:"d-m-Y H:i" }}</b></span></p>
    {% if object.tags.all %}
        <p>Теги:
            {% for tag in object.tags.all %}
                <a href="{% url 'blog:tag' tag.slug %}">_{{ tag.name }}_</a>
            {% endfor %}
        </p>
    {% endif %}
    <div class="cleaner h10"></div>
    <h5>Автор статьи</h5>
    <p>
        <b>{{ object.user.username }} </b>
        {% if object.user.first_name %}
           - {{ object.user.first_name }} {{ object.user.last_name }}<br>
        {% endif %}
        {{ object.user.bio }}<br>
        {% if object.user.git %}
            <a target="_blank"  href="{{ object.user.git }}">GitHub {{ object.user.username }}</a>
        {% endif %}
    </p>
    <div class="cleaner h10"></div>
    <div class="cleaner h10"></div>
    <div class="d-flex-space-between">
        <a class="more float_r" href="" onclick="javascript:history.back(); return false;">Назад</a>
        {% if is_author %}
            <a class="more float_l" href="{% url 'blog:post-update' object.slug %}">Править</a>
        {% endif %}
    </div>
</div>

<div class="post_box_content">
    <br><br>
    <h4>Комментарии</h4>
</div>

{% if user.is_authenticated %}
    {% if user.is_email_activated %}
    <div id="cp_contact_form">
        <form method="post" name="contact">
            {% csrf_token %}
            {{ form.as_p }}
            <div class="cleaner h10"></div>
            <input type="submit" value="Отправить" id="submit" name="submit" class="submit_btn float_l" />
        </form>
    </div>
    {% else %}
        <div class="post_box_content">
            <div class="cleaner h10"></div>
            <p>Подтвердите адрес E-mail: {{ user.email }} чтобы оставить комментарий.</p>
            <p><a href="{% url 'repeat-send-email' %}">Повторно отправить сообщение для активации e-mail.</a></p>
            <div class="cleaner h10"></div>
        </div>
    {% endif %}
{% else %}
    <div class="post_box_content">
        <div class="cleaner h10"></div>
        <a href="{% url 'login' %}">Авторизуйтесь</a> чтобы оставить комментарий.
    </div>
{% endif %}

{% if comments %}
<div class="post_box_content">
    <div class="cleaner h10"></div>
</div>
    {% for comment in comments %}
    <div class="post_box">
        <div class="post_box_date">
            {{ comment.time_created|date:"d-m-Y H:i" }}
            <span>{{ comment.user__username }}</span>
        </div>

        <div class="post_box_comment_content"><p>{{ comment.body|extra_space }}</p><hr></div>
    </div>
    {% endfor %}
{% endif %}
<div class="cleaner h10"></div>
<div class="cleaner h10"></div>
{% endblock %}

msdevblog/blog/templates/blog/post_list.html
{% extends 'blog/base.html' %}

{% block content %}
    {% for post in object_list %}
    <div class="post_box_content list">

        <h2><a href="{% url 'blog:post-detail' post.slug %}">{{ post.title }}</a></h2>
        <p>{{ post.body|safe|truncatewords_html:30 }}</p>
        <p><span><b>{{ post.time_updated|date:"d-m-Y H:i" }}</b> - {{ post.user.username }}</span></p>

        {% if post.tags %}
        <p>Теги:
            {% for tag in post.tags.all %}
                <a href="{% url 'blog:tag' tag.slug %}">_{{ tag.name }}_</a>
            {% endfor %}
        </p>
        {% endif %}

        <a class="more float_r" href="{% url 'blog:post-detail' post.slug %}">Читать</a>
    </div>
    {% endfor %}

    {% if page_obj.paginator.num_pages > 1 %}
    <div class="cleaner h10"></div>
    <div class="cleaner h10"></div>
    <div class="cleaner h10"></div>
    <div class="post_box_content list">
        <div class="d-flex-space-around">

            {% if page_obj.has_previous %}
                <a href="?page=1">&laquo; Первая</a>
                <a href="?page={{ page_obj.previous_page_number }}">{{ page_obj.previous_page_number }}</a>
            {% endif %}
                {{ page_obj.number }} из {{ page_obj.paginator.num_pages }}
            {% if page_obj.has_next %}
                <a href="?page={{ page_obj.next_page_number }}">{{ page_obj.next_page_number }}</a>
                <a href="?page={{ page_obj.paginator.num_pages }}">Последняя &raquo;</a>
            {% endif %}

        </div>
    </div>
    {% endif %}

{% endblock %}